StarObjectModel Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
StarObjectModel Class Reference

the main class to read a SdrModel zone More...

`#include <StarObjectModel.hxx>`

Inheritance diagram for StarObjectModel:

## Public Member Functions
| StarObjectModel (StarObject const &orig, bool duplicateState)
| constructor More...
| ~StarObjectModel () override
| destructor More...
bool | read (StarZone &zone)
| try to read a SdrModel zone: "DrMd" More...
void | updateObjectIds (std::set< long > &unusedId)
| try to update the object id of page 0 More...
bool | updatePageSpans (std::vector< STOFFPageSpan > &pageSpan, int &numPages, bool usePage0=false) const
| try to update the page span (to create draw document) More...
bool | sendMasterPages (STOFFGraphicListenerPtr listener)
| try to send the master pages More...
bool | sendPages (STOFFListenerPtr listener)
| try to send the different page More...
bool | sendPage (int pageId, STOFFListenerPtr listener, bool masterPage=false)
| try to send a page content More...
bool | sendObject (int id, STOFFListenerPtr listener, StarState const &state)
| try to send an object More...
Public Member Functions inherited from StarObject
| StarObject (char const *passwd, std::shared_ptr< STOFFOLEParser > &oleParser, std::shared_ptr< STOFFOLEParser::OleDirectory > &directory)
| constructor More...
virtual | ~StarObject ()
| destructor More...
bool | parse ()
| try to parse data More...
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind More...
char const * | getPassword () const
| returns the document password (the password given by the user) More...
std::shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory More...
std::shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager More...
std::shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager More...
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation) More...
librevenge::RVNGString | getUserNameMetaData (int i) const
| returns the ith user meta data More...
void | cleanPools ()
| clean each pool More...
std::shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document More...
std::shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it. More...
std::shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool More...
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data More...
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets More...
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=nullptr, bool isDirect=false)
| try to read a list of item More...

## Protected Member Functions
bool | readSdrLayer (StarZone &zone, StarObjectModelInternal::Layer &layer)
| try to read a SdrLayer zone: "DrLy' More...
bool | readSdrLayerSet (StarZone &zone, StarObjectModelInternal::LayerSet &layers)
| try to read a SdrLayerSet zone: "DrLS' More...
std::shared_ptr< StarObjectModelInternal::Page > | readSdrPage (StarZone &zone)
| try to read a Page/MasterPage zone: "DrPg' More...
bool | readSdrMPageDesc (StarZone &zone, StarObjectModelInternal::Page &page)
bool | readSdrMPageDescList (StarZone &zone, StarObjectModelInternal::Page &page)
bool | readSdrPageUnknownZone1 (StarZone &zone, long lastPos)
| try to read a zone which appear at end of a zone: "DrPg' More...
Protected Member Functions inherited from StarObject
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object More...
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation" More...
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview" More...
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows" More...
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File" More...
bool | readStarFrameworkConfigItem (STOFFEntry &entry, STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read an item in a "Star Framework Config File" More...
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor More...

## Protected Attributes
std::shared_ptr< StarObjectModelInternal::State > | m_modelState
| the state More...
Protected Attributes inherited from StarObject
char const * | m_password
| the document password More...
std::shared_ptr< STOFFOLEParser > | m_oleParser
| the ole parser More...
std::shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory More...
std::shared_ptr< StarObjectInternal::State > | m_state
| the state More...
librevenge::RVNGPropertyList | m_metaData
| the meta data More...

## Private Member Functions
StarObjectModel & | operator= (StarObjectModel const &orig)=delete

## Friends
std::ostream & | operator<< (std::ostream &o, StarObjectModel const &model)
| small operator<< to print the content of the model More...

## Detailed Description

the main class to read a SdrModel zone

## Constructor & Destructor Documentation

## ◆ StarObjectModel()

StarObjectModel::StarObjectModel | ( | StarObject const & | orig,
|  | bool | duplicateState
| ) |  |

constructor

## ◆ ~StarObjectModel()

StarObjectModel::~StarObjectModel | ( |  | ) |
| override

destructor

## Member Function Documentation

## ◆ operator=()

StarObjectModel& StarObjectModel::operator= | ( | StarObjectModel const & | orig | ) |
| privatedelete

## ◆ read()

bool StarObjectModel::read | ( | StarZone & | zone | ) |

try to read a SdrModel zone: "DrMd"

## ◆ readSdrLayer()

bool StarObjectModel::readSdrLayer | ( | StarZone & | zone,
|  | StarObjectModelInternal::Layer & | layer
| ) |  |
| protected

try to read a SdrLayer zone: "DrLy'

Referenced by read(), and readSdrPage().

## ◆ readSdrLayerSet()

bool StarObjectModel::readSdrLayerSet | ( | StarZone & | zone,
|  | StarObjectModelInternal::LayerSet & | layers
| ) |  |
| protected

try to read a SdrLayerSet zone: "DrLS'

Referenced by read(), and readSdrPage().

## ◆ readSdrMPageDesc()

bool StarObjectModel::readSdrMPageDesc | ( | StarZone & | zone,
|  | StarObjectModelInternal::Page & | page
| ) |  |
| protected

Referenced by readSdrMPageDescList(), and readSdrPage().

## ◆ readSdrMPageDescList()

bool StarObjectModel::readSdrMPageDescList | ( | StarZone & | zone,
|  | StarObjectModelInternal::Page & | page
| ) |  |
| protected

Referenced by readSdrPage().

## ◆ readSdrPage()

std::shared_ptr< StarObjectModelInternal::Page > StarObjectModel::readSdrPage | ( | StarZone & | zone | ) |
| protected

try to read a Page/MasterPage zone: "DrPg'

Referenced by read().

## ◆ readSdrPageUnknownZone1()

bool StarObjectModel::readSdrPageUnknownZone1 | ( | StarZone & | zone,
|  | long | lastPos
| ) |  |
| protected

try to read a zone which appear at end of a zone: "DrPg'

## ◆ sendMasterPages()

bool StarObjectModel::sendMasterPages | ( | STOFFGraphicListenerPtr | listener | ) |

try to send the master pages

## ◆ sendObject()

bool StarObjectModel::sendObject | ( | int | id,
|  | STOFFListenerPtr | listener,
|  | StarState const & | state
| ) |  |

try to send an object

## ◆ sendPage()

bool StarObjectModel::sendPage | ( | int | pageId,
|  | STOFFListenerPtr | listener,
|  | bool | masterPage = `false`
| ) |  |

try to send a page content

Referenced by sendMasterPages(), and sendPages().

## ◆ sendPages()

bool StarObjectModel::sendPages | ( | STOFFListenerPtr | listener | ) |

try to send the different page

## ◆ updateObjectIds()

void StarObjectModel::updateObjectIds | ( | std::set< long > & | unusedId | ) |

try to update the object id of page 0

Note
  this is used to retrieve an object in a .sdw's DrawingLawer stream

## ◆ updatePageSpans()

bool StarObjectModel::updatePageSpans | ( | std::vector< STOFFPageSpan > & | pageSpan,
|  | int & | numPages,
|  | bool | usePage0 = `false`
| ) |  | const

try to update the page span (to create draw document)

## Friends And Related Function Documentation

## ◆ operator<<

std::ostream& operator<< | ( | std::ostream & | o,
|  | StarObjectModel const & | model
| ) |  |
| friend

small operator<< to print the content of the model

## Member Data Documentation

## ◆ m_modelState

std::shared_ptr<StarObjectModelInternal::State> StarObjectModel::m_modelState
| protected

the state

Referenced by operator<<(), read(), sendMasterPages(), sendObject(), sendPage(), sendPages(), updateObjectIds(), and updatePageSpans().

The documentation for this class was generated from the following files:

- StarObjectModel.hxx
- StarObjectModel.cxx